;**********************************************
; Code for RS-232 communication, to be included in
; your program.
;
;
;**********************************************

#include "config.inc"

#ifndef RS232_PORT
	error	"RS232_PORT must be defined, for example: PORTA,0"
#endif
#ifndef RS232_BAUD
	error	"RS232_BAUD must be defined, for example: 9600"
#endif
#ifndef CLOCKSPEED
	error	"CLOCKSPEED must be defined, for example: .8000000"
#endif


	udata
Temp			res 1
Counter			res 1
DelayCounter 	res 1

	code

; Sends W 	
RS232_Init
	global	RS232_Init

	bsf		RS232_PORT
	call	RS232_Send_w_delay
	
	return


RS232_Send_W
	global	RS232_Send_W

	movwf	Temp
	movlw	0x08
	movwf	Counter
	; send start bit
	bcf		RS232_PORT
	call	RS232_Send_w_delay
RS232_Send_w_loop
	rrf		Temp
	BTFSS   STATUS, C
    BCF     RS232_PORT
	BTFSC   STATUS, C
	BSF     RS232_PORT
	call	RS232_Send_w_delay
	decfsz	Counter
	goto	RS232_Send_w_loop
	
	; send stop bit
	bsf		RS232_PORT
	call	RS232_Send_w_delay
	call	RS232_Send_w_delay
	return

RS232_Send_w_delay
	if (CLOCKSPEED == .4000000 && RS232_BAUD == .9600)
		movlw	0x1f
	else
		if (CLOCKSPEED == .4000000 && RS232_BAUD == .4800) || (CLOCKSPEED == .8000000 && RS232_BAUD == .9600)
			movlw	0x41
		else
			if (CLOCKSPEED == .8000000 && RS232_BAUD == .4800)
				movlw	0x87
			else
				error	"Unimplemented clockspeed/baud configuration"
			endif
		endif
	endif
	
	movwf	DelayCounter
	decfsz	DelayCounter, F
	goto	$-1
	return	

	end